import { mount } from 'vue-test-utils'
import inputMixin from '../src/input-mixin'

describe('Input mixin', () => {
  it('should be a function', () => {
    expect(typeof inputMixin).toBe('function')
  })
  it('should return an object', () => {
    expect(typeof inputMixin(Array)).toBe('object')
  })
  it('should return a mixin that has `input` method', () => {
    expect(inputMixin()).toHaveProperty('methods.input')
  })
  it('should return a mixin that has `error` computed property', () => {
    expect(inputMixin()).toHaveProperty('computed.error')
  })
  it('should emit `input` event when the `input` method is called', () => {
    const wrapper = mount(inputMixin())
    wrapper.vm.input()
    expect(wrapper.emitted().input).toBeTruthy()
  })
})
